<template>
  <div class="page">
    <div
      v-if="routeFrom && routeFrom.name === 'Data'"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des données
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Resources' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Liste des ressources
      </span>
    </div>
    <div
      class="add-dataset-form"
    >
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        style="min-height: 30em;"
      >
        <h2>Nouvelle ressource</h2>
        <ValidationObserver v-slot="{ handleSubmit }">
          <form>
            <h3 class="line-header">
              <img
                src="@/assets/icons/form_description_file.svg"
                alt="Icône fichier"
              /> Fiche ressource
            </h3>
            <div class="form-row">
              <div class="form-group col-12">
                <label class="required">Titre</label>
                <ValidationProvider rules="required" v-slot="{ classes, errors }">
                  <div class="control" :class="classes">
                    <input
                      v-model="form.titre"
                      class="form-control"
                      :class="{}"
                      type="text"
                      placeholder="Titre"
                    >
                    <span class="form-errors">{{ errors[0] }}</span>
                  </div>
                </ValidationProvider>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group col-8">
                <label class="required" style="margin-top: 1em;">Format de la ressource</label>
                <p>Sélectionner un format dans la liste</p>
                <ValidationProvider rules="required" v-slot="{ classes, errors }">
                  <div class="control" :class="classes">
                    <Multiselect
                      v-model="form.format"
                      :options="resourceDataFormats"
                      track-by="codename"
                      label="display_name"
                      selectLabel=""
                      selectedLabel=""
                      deselectLabel=""
                      :searchable="false"
                      placeholder="Format de la ressource"
                    />
                    <span class="form-errors">{{ errors[0] }}</span>
                  </div>
                </ValidationProvider>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group col-8">
                <label>Ressource</label>
                <p>Importer la ressource</p>
                <ImportFile
                  :type="'ressource'"
                  :accept="form.format ?
                    resourceDataFormats.find(el => el.codename === form.format.codename).extension.map(el => { return `.${el}` }).join(',') :
                    ''
                  "
                  :disabled="!(form.format && form.format.codename)"
                  @update="setResourceFile"
                />
              </div>
            </div>
            <div class="form-row">
              <div class="form-group col-12">
                <label>Description de la ressource</label>
                <textarea
                  v-model="form.description"
                  class="form-control"
                />
              </div>
            </div>
            <h3 class="line-header">
              <img
                src="@/assets/icons/company.svg"
                alt="Icône organisation"
              /> Organisation
            </h3>
            <div class="form-row">
              <div class="form-group col-12">
                <label style="margin-top: 1em;">Nom de l'organisation</label>
                <p>Sélectionner une organisation dans la liste</p>
                <ValidationProvider rules="required" v-slot="{ classes, errors }">
                  <div class="control" :class="classes">
                    <Multiselect
                      v-model="form.organisation"
                      :options="organisationsList"
                      track-by="id"
                      label="display_name"
                      selectLabel=""
                      selectedLabel=""
                      deselectLabel=""
                      :searchable="false"
                      placeholder="Nom de l'organisation"
                    />
                    <span class="form-errors">{{ errors[0] }}</span>
                  </div>
                </ValidationProvider>
              </div>
            </div>
            <div class="form-footer">
              <b-button
                variant="outline-secondary"
                @click="$router.go(-1)"
              >
                Annuler
              </b-button>
              <b-button
                variant="primary"
                @click="handleSubmit(createResource)"
              >
                Enregistrer
              </b-button>
            </div>
          </form>
        </ValidationObserver>
      </b-overlay>
    </div>
  </div>
</template>

<script>
import ImportFile from '@/components/ImportFile.vue';
import Multiselect from 'vue-multiselect';

import { mapState, mapActions } from 'vuex';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'AddDataset',

  components: {
    ImportFile,
    Multiselect,
    ValidationObserver,
    ValidationProvider
  },

  data() {
    return {
      routeFrom: null,
      loading: false,
      form: {
        titre: null,
        description: null,
        organisation: null,
        format: null
      },
      resourceFile: null
    };
  },

  computed: {
    ...mapState('organisations', ['organisationsList']),
    ...mapState('resources', [
      'resourceDataFormats',
      'resourceKinds'
    ])
  },

  created() {
    if (this.organisationsList.length === 0) {
      this.GET_ORGANISATIONS_LIST({
        direction: null,
        field: null
      });
    }
    if (this.resourceDataFormats.length === 0) {
      this.GET_RESOURCE_DATA_FORMATS();
    }
    if (this.resourceKinds.length === 0) {
      this.GET_RESOURCE_KINDS();
    }
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  methods: {
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST'
    ]),
    ...mapActions('resources', [
      'GET_RESOURCES_LIST',
      'GET_RESOURCE_DATA_FORMATS',
      'GET_RESOURCE_KINDS',
      'CREATE_FILE_UPLOAD_RESOURCE'
    ]),

    setResourceFile(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.resourceFile = formData;
    },

    createResource() {
      // resourcesAPI.createFileUploadFormat(this.form.format.codename)
      //   .then((resp) => {
      //     resourcesAPI.createFileUploadFile(resp.id, this.resourceFile)
      //       .then((resp) => {
      //         resourcesAPI.createFileUploadInspect(resp.id)
      //           .then((resp) => {
      //             const data = {
      //               kwargs: {
      //                 display_name: this.form.titre,
      //                 description: this.form.description,
      //                 usergroup_pk: this.form.organisation.usergroup.id
      //               }
      //             };
      //             resourcesAPI.createFileUploadResource(resp.id, data);
      //           })
      //       })
      //   });
      const data = {
        ...this.form,
        file: this.resourceFile
      };
      this.loading = true;
      this.CREATE_FILE_UPLOAD_RESOURCE(data)
      .then(() => {
        this.loading = false;
      });
    }
  }
}
</script>

<style lang="less" scoped>
.add-dataset-form {
  display: flex;
  width: 100%;
  margin-left: 3em;
  form {
    min-width: 800px;
  }
}

h2 {
  color: @blue;
  text-shadow: 0 0 2px @lightBlue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

</style>
